#include <stdio.h>
#include "mcrypt.h"
#include <stdlib.h>
#include <string.h>
#include "mhash.h"
main (int argc,char* argv[]){
  MCRYPT td;
  char password[32];
  FILE *ifile;
  FILE *ofile;
  char *block_buffer;
  char *key;
  char *IV;
  int keysize;
  int blocksize;
  int flag,i;

  ifile=fopen(argv[1],"r");
  ofile=fopen(argv[2],"w");
  printf("Cifrado de ficheros con GOST en modo CFB\n");
  printf("sintaxis:gost file_in file_out passw flag(1 cif 2 decif)\n");
  printf("Fichero de entrada: %s\n",argv[1]);
  printf("Fichero de salida: %s\n",argv[2]);
  strcpy(&password[0],argv[3]);
  flag=atoi(argv[4]);
  printf("Flag cif/decif: %d\n",flag);
    printf("passw: %s \n",password);
  td=mcrypt_module_open("gost",NULL,"cfb",NULL);

  keysize=mcrypt_enc_get_block_size(td);
    printf("llave %d bytes\n",keysize);
  key=calloc(1,keysize);
    mhash_keygen(KEYGEN_MCRYPT, MHASH_GOST,0, key, keysize,NULL, 0, password, strlen(password));
    
  if(td==MCRYPT_FAILED){
    return 1;
  }

  blocksize=mcrypt_enc_get_block_size(td);
  printf("bloque %d bytes\n",blocksize);
  block_buffer=malloc(blocksize);
  IV=malloc(mcrypt_enc_get_iv_size(td));

    for (i=0;i<mcrypt_enc_get_iv_size(td);i++){
      IV[i]=rand();
    }
  mcrypt_generic_init(td,key,keysize,IV);
    while(fread(block_buffer,1,blocksize,ifile)==blocksize){
     
      if (flag==0){
	mcrypt_generic(td,block_buffer,blocksize);
      }
      if(flag==1){
	mdecrypt_generic(td,block_buffer,blocksize);
      }
      
    fwrite(block_buffer,1,blocksize,ofile);
    }

  mcrypt_generic_deinit(td);
  mcrypt_module_close(td);
  close(ifile);
  close(ofile);

}
