#include <stdio.h>
#include <stdlib.h>
#include "mhash.h"
main(int argc,char* argv[]){
  MHASH td;
  FILE *ifile;
  unsigned char *buffer;
  unsigned char *hash;
  int block_size,i;  
  printf("Hashing de ficheros con GOST\n");
  ifile=fopen(argv[1],"r");
  printf("Fichero de entrada %s\n",argv[1]);
  td=mhash_init(MHASH_GOST);
  while (fread(buffer,1,1,ifile) == 1){
    mhash(td,buffer,1);
  }
  hash=mhash_end(td);
  block_size=mhash_get_block_size(MHASH_GOST);
  printf("block %d bytes\n",block_size);
  printf("hash\n");
  for (i=0;i<block_size;i++){
    printf("%.2x",hash[i]);
  }
  printf("\n");
}
